/*
	 Murielle Descerisiers, 2009
	murielle.descerisiers@gmail.com

	Ce logiciel est un programme informatique dvelopp au Qubec et servant 
	consulter le dictionnaire de la langue franaise d'mile Littr.

	Ce logiciel est rgi par la licence CeCILL soumise au droit franais et respectant
	les principes de diffusion des logiciels libres. Vous pouvez utiliser, modifier et/ou
	redistribuer ce programme sous les conditions de la licence CeCILL telle que diffuse
	par le CEA, le CNRS et l'INRIA sur le site http://www.cecill.info.

	En contrepartie de l'accessibilit au code source et des droits de copie, de
	modification et de redistribution accords par cette licence, il n'est offert aux
	utilisateurs qu'une garantie limite. Pour les mmes raisons, seule une
	responsabilit restreinte pse sur l'auteur du programme, le titulaire des droits
	patrimoniaux et les concdants successifs.

	 cet gard l'attention de l'utilisateur est attire sur les risques associs au
	chargement,  l'utilisation,  la modification et/ou au dveloppement et  la
	reproduction du logiciel par l'utilisateur tant donn sa spcificit de logiciel
	libre, qui peut le rendre complexe  manipuler et qui le rserve donc  des
	dveloppeurs et des professionnels avertis possdant des connaissances informatiques
	approfondies. Les utilisateurs sont donc invits  charger et tester l'adquation du
	logiciel  leurs besoins dans des conditions permettant d'assurer la scurit de
	leurs systmes et ou de leurs donnes et, plus gnralement,  l'utiliser et
	l'exploiter dans les mmes conditions de scurit.

	Le fait que vous puissiez accder  cet en-tte signifie que vous avez pris
	connaissance de la licence CeCILL, et que vous en avez accept les termes.
*/

#ifndef CLASSERECHERCHE_H
#define CLASSERECHERCHE_H

#include <QDialog>
#include <QTextDocumentFragment>
#include <QCloseEvent>

#include "ui_classerecherche.h"
#include "classeminuterierouge.h"
#include "classeprincipale.h"

class classePrincipale;

class classeRecherche : public QDialog, public Ui::fenetreRecherche
{
	Q_OBJECT
public:
	classeRecherche(QWidget *parent = 0, Qt::WindowFlags f = /*0*/Qt::WindowFlags());

	int nombreEntree;
	QString texteRecherche;
	bool boolArretUrgence;
private:
	QAction *actionExporterHTML,
		*actionExporterODF,
		*actionExporterTXT,
		*actionExporterPDF;
	classePrincipale *fenetrePrincipale;

	QTextDocument *CreerDocument();
	QString CreerEntete(const int nombreIndexEntree);
	void ActiverOuDesactiver(bool boolActiver, const int nombreResultats = -1);
	bool EstSusceptible(QString texte, const Qt::CaseSensitivity respecterCasse,
		const bool boolExpressionRationnelle);
	void AjouterAvertissementAuxResultats(const QString &texte);
protected:
	void closeEvent(QCloseEvent *event);
private slots:
	void Consulter();
	void Chercher(QString texteParametre = QString());
	void EvenementResultatChoisi();
	void FermerOuAnnuler();
	void ApercuImpression(QPrinter *printer);
	void AfficherApercuImpression();
	void Exporter();
	void Imprimer();
	void EvenementAccessibleZoneListe(const QModelIndex &index);
	void EvenementAccessibleAction();
};

#endif
